function [ERRis]=MLZ_TRF_SYSTEM_MANY_ARGS_FIXED_COSTS(X0, N , S, mu, Yi3D, Yj3D, yis3D, ysjk3D, Dj3D, Dj_h3D, alpha_tilde_sjk3D, betajs3D, epsilon_s3D, theta_s3D, eta_s3D, delta_s3D, sigma_s3D, tijs3D, tijs_p3D, phiijs_h3D, Lijs3D, LABOR)
% the current function returns the vector of differences between left- and righthand sides of the system
% "_h" shands for "hat", "3D" stands for "cubes" ordered as (i,j,s), "_p" stands for "prime"
% use (X0(...).^2) to avoid complex numbers in solutions
% summer vectors
ln=ones(N,1);
X0=(X0).^2; % to avoid complex numbers

% construct 3D cubes from 1D vector X0
cis_h=X0(1:N*S,1);
cis_h2D=reshape(cis_h,S,N);
cis_h3D=reshape(kron(cis_h2D',ln'),N,N,S);
cjs_h3D=permute(cis_h3D,[2 1 3]);
yis_h=X0((N*S+1):(2*N*S),1);
yis_h2D=reshape(yis_h,S,N);
yis_h3D=reshape(kron(yis_h2D',ln'),N,N,S);
wi_h=X0((2*N*S+1):end,1);
wi_h3D=repmat(wi_h,[1 N S]);
wj_h3D=permute(wi_h3D,[2 1 3]);
ysjk_h3D=repmat(yis_h2D,[1 1 S]);	% y^_j,s in (s,j,k)
wsjk_h3D=repmat(wi_h',[S 1 S]);		% w^_j in (s,j,k)

if LABOR==1     % case when only labor enters fixed costs
    
    %mult_alpha=1-delta_s3D.*(1+eta_s3D)./(epsilon_s3D+1+eta_s3D);
    %alpha_sjk3D=alpha_tilde_sjk3D./repmat(reshape(mult_alpha(1,1,:),S,1),[1 N S]);  % alphas adjusted for fixed costs in labor
    %alpha_sj3D=repmat(sum(alpha_sjk3D,3),[1 1 S]);  % alpha_sj in (s,j,k)
    %alpha_si3D=permute(repmat(alpha_sj3D(:,:,1),[1 1 N]),[2 3 1]);
    
    
    %PHIis3D=(sigma_s3D-delta_s3D)./((1-alpha_si3D).*(sigma_s3D-delta_s3D)+delta_s3D); % PHI_i,s in (i,j,s)
    %PHIiks3D=repmat(PHIis3D(:,1,:),[1 S 1]); % PHI_i,s in (i,k,s)
    %PHIsjk3D=permute(PHIiks3D,[3 1 2]);	% PHI_j,s in (s,j,k)

    %Yi=Yi3D(:,1,1);
    %Ysjk3D=repmat(Yi',[S 1 S]);	% Y_j, (s,j,k)
    %kj3D=1./(1-repmat(sum(sum(tijs3D.*Lijs3D.*betajs3D./(1+tijs3D),3),1),[N 1 S])); % kappa_j in (i,j,s)

    %AUX5_LABsjk=alpha_sjk3D.*PHIsjk3D.*ysjk3D.*Ysjk3D;
    %AUX5_LAB=repmat(sum(AUX5_LABsjk,1),[N 1 1]);   %(i,j,s)
    %AUX6_LAB=repmat(sum(sum(tijs3D.*Lijs3D.*AUX5_LAB./(1+tijs3D),3),1),[N 1 S]);
    %Ejs3D=betajs3D.*kj3D.*(Yj3D+Dj3D+AUX6_LAB)+AUX5_LAB;  % Ejs for labor in fixed costs
    %%CHECK: ERR00=Xijs3D-Lijs3D.*Ejs3D;
        
    %AUX0=Lijs3D.* (yis_h3D.^delta_s3D).* ((cis_h3D.*phiijs_h3D).^(-theta_s3D)).*(wi_h3D.^(-eta_s3D.*delta_s3D));
    %AUX1=repmat(sum(AUX0,1),[N 1 1]);   % NxNxS (i,j,s)
    %AUX2=AUX0./AUX1;    % lambda^ * lambda

    %AUX3sjk=alpha_sjk3D.*PHIsjk3D.*ysjk_h3D.*ysjk3D.*Ysjk3D.*wsjk_h3D;    % (s,j,k)
    %AUX3=repmat(sum(AUX3sjk,1),[N 1 1]);   %(i,j,s)
    %AUX3_5=repmat(sum(sum(tijs_p3D.*AUX2.*AUX3./(1+tijs_p3D),3),1),[N 1 S]);
    %kj_p3D=1./(1-repmat(sum(sum(tijs_p3D.*AUX2.*betajs3D./(1+tijs_p3D),3),1),[N 1 S])); % kappa'_j in (i,j,s)
    %AUX4=betajs3D.*kj_p3D.*(wj_h3D.*Yj3D+Dj3D.*Dj_h3D.*(wj_h3D.^mu)+AUX3_5)+AUX3;   % Ejs^ * Ejs
    %AUX7=AUX4./Ejs3D;    % E^js

    %% === EQN1 ===
    %AUX9=Lijs3D.* (yis_h3D.^delta_s3D).* ((cis_h3D.*phiijs_h3D).^(-theta_s3D)).*((AUX7./wi_h3D).^(delta_s3D.*eta_s3D));
    %AUX9sjk=repmat(sum(AUX9,1),[S 1 1]);    % summ over i; (j,s) now becomes (j,k) in (s,j,k) coordinates
    %theta_k3D=repmat(theta_s3D(1,1,:),[S N 1]); % theta_k in (s,j,k) 
    %AUX8=-alpha_sjk3D./(theta_k3D); % SxNxS (s,j,k), alpha_sjk means flow from "k" to "s" in country "j"
    %AUX10sjk=AUX9sjk.^AUX8;
    %AUX10=permute(repmat(prod(AUX10sjk,3),[1 1 N]),[3 2 1]);    %(i,j,s)
    %ERR1js3D=cjs_h3D-(wj_h3D.^(1-permute(alpha_si3D,[2 1 3]))).*AUX10; %(i,j,s)
    %ERR1sji=permute(ERR1js3D,[3 2 1]);  % (s,j,i)
    %ERR1=reshape(ERR1sji(:,:,1),N*S,1);  % j,s -- s changes first

    %% === EQN2 ===
    %AUX11=PHIis3D.*sigma_s3D.*wi_h3D.*yis_h3D.*yis3D.*Yi3D./(sigma_s3D-delta_s3D);
    %AUX12=repmat(sum(AUX2.*AUX4./(1+tijs_p3D),2),[1 N 1]);
    %ERR2ijs=AUX11-AUX12;
    %ERR2is=reshape(ERR2ijs(:,1,:),N,S);
    %ERR2=reshape(ERR2is',N*S,1);	% i,s -- s changes first
    %%ERR2((N-1)*S,1)=wi_h((N-1),1)-1; % replace one equation (for US sector 35) with normalization w^US=1

    %% === EQN3 ===
    %EQ3LHS=sum(yis_h3D.*yis3D,3);
    %ERR3=EQ3LHS(:,1)-1;
    %ERR3(N,1)=sum(Yi3D(:,1,1).*(wi_h-1));    % replace one excess equation with normalization,w^=w'/w=1, where w=sum_i(wi'*Li)/sum(wi*Li);

    %% === ALL EQUATIONS ===
    %ERRis=[ERR1;ERR2;ERR3];

else            % case when both labor and intermediate goods enter fixed costs
    
    alpha_sjk3D=alpha_tilde_sjk3D;  % alphas should not be adjusted if fixed costs include bundle of intermediate goods
    alpha_sj3D=repmat(sum(alpha_sjk3D,3),[1 1 S]);
    alpha_si3D=permute(repmat(alpha_sj3D(:,:,1),[1 1 N]),[2 3 1]);  % alpha_is in (i,j,s)
    
    Yi=Yi3D(:,1,1);
    Ysjk3D=repmat(Yi',[S 1 S]);	% Y_j, (s,j,k)
    kj3D=1./(1-repmat(sum(sum(((1-1./sigma_s3D).^delta_s3D).*tijs3D.*Lijs3D.*betajs3D./(1+tijs3D),3),1),[N 1 S])); % kappa_j in (i,j,s)
    
    AUX5_INTsjk=alpha_sjk3D.*ysjk3D.*Ysjk3D./(1-alpha_sj3D);
    AUX5_INT=repmat(sum(AUX5_INTsjk,1),[N 1 1]);   % last summand in Equation (10), in coordinates (i,j,s)
    AUX6_INT=repmat(sum(sum(((1-1./sigma_s3D).^delta_s3D).*tijs3D.*Lijs3D.*AUX5_INT./(1+tijs3D),3),1),[N 1 S]); % last summand in brackets (in numerator) of Equation (10)
    Ejs3D=betajs3D.*kj3D.*(Yj3D+Dj3D+AUX6_INT)+AUX5_INT;  % Ejs for intermed. goods in fixed costs

    AUX0=Lijs3D.* (yis_h3D.*wi_h3D./cis_h3D).^delta_s3D .* (cis_h3D.*phiijs_h3D).^(-theta_s3D).*(cis_h3D.^(-eta_s3D.*delta_s3D)); % numerator of the expression for lambda* lambda^
    AUX1=repmat(sum(AUX0,1),[N 1 1]);   % denominator of the expression for lambda* lambda^, NxNxS (i,j,s)
    AUX2=AUX0./AUX1;    % lambda^ * lambda

    AUX3sjk=alpha_sjk3D.*ysjk_h3D.*ysjk3D.*Ysjk3D.*wsjk_h3D./(1-alpha_sj3D);    % (s,j,k)
    AUX3=repmat(sum(AUX3sjk,1),[N 1 1]);   % the last summand in the expression for Ejs^ * Ejs, Equation (16), in (i,j,s)
    AUX3_5=repmat(sum(sum(((1-1./sigma_s3D).^delta_s3D).*tijs_p3D.*AUX2.*AUX3./(1+tijs_p3D),3),1),[N 1 S]);
    kj_p3D=1./(1-repmat(sum(sum(((1-1./sigma_s3D).^delta_s3D).*tijs_p3D.*AUX2.*betajs3D./(1+tijs_p3D),3),1),[N 1 S])); % kappa'_j in (i,j,s), expression for E^_js *E_js
    AUX4=betajs3D.*kj_p3D.*(wj_h3D.*Yj3D+Dj3D.*Dj_h3D.*(wj_h3D.^mu)+AUX3_5)+AUX3;   % Ejs^ * Ejs
    AUX7=AUX4./Ejs3D;    % E^js

    % === EQN1 ===
    AUX9=Lijs3D.* ((yis_h3D.*wi_h3D./cis_h3D).^delta_s3D).* ((cis_h3D.*phiijs_h3D).^(-theta_s3D)).*((AUX7./cis_h3D).^(delta_s3D.*eta_s3D)); % expression under the summation operation in Equation (14)
    AUX9sjk=repmat(sum(AUX9,1),[S 1 1]);
    theta_k3D=repmat(theta_s3D(1,1,:),[S N 1]); % theta_k in (s,j,k) 
    AUX8=-alpha_sjk3D./(theta_k3D); % SxNxS (s,j,k), alpha_sjk means flow from "k" to "s" in country "j"
    AUX10sjk=AUX9sjk.^AUX8;
    AUX10=permute(repmat(prod(AUX10sjk,3),[1 1 N]),[3 2 1]);    % product over k, Equation (14), in (i,j,s)
    ERR1js3D=cjs_h3D-(wj_h3D.^(1-permute(alpha_si3D,[2 1 3]))).*AUX10; %(i,j,s)
    ERR1sji=permute(ERR1js3D,[3 2 1]);  % (s,j,i)
    ERR1=reshape(ERR1sji(:,:,1),N*S,1);  % j,s -- s changes first

    % === EQN2 ===
    AUX11=wi_h3D.*yis_h3D.*yis3D.*Yi3D./(1-alpha_si3D);
    AUX12=repmat(sum(((1+tijs_p3D./sigma_s3D).^delta_s3D).*AUX2.*AUX4./(1+tijs_p3D),2),[1 N 1]);
    ERR2ijs=AUX11-AUX12;
    ERR2is=reshape(ERR2ijs(:,1,:),N,S);
    ERR2=reshape(ERR2is',N*S,1);	% i,s -- s changes first
    %ERR2((N-1)*S,1)=wi_h((N-1),1)-1; % replace one equation (for US sector 35) with normalization w^US=1

    % === EQN3 ===
    EQ3LHS=sum(yis_h3D.*yis3D,3);
    ERR3=EQ3LHS(:,1)-1;
    ERR3(N,1)=sum(Yi3D(:,1,1).*(wi_h-1));    % replace one excess equation with normalization,w^=w'/w=1, where w=sum_i(wi'*Li)/sum(wi*Li);

    % === ALL EQUATIONS ===
    ERRis=[ERR1;ERR2;ERR3];

end

end
