function [Cj]=...
    MLZ_WELFARE_CORRECTED(x_fsolve, N , S, mu, Yi3D, Yj3D, ysjk3D, Ris3D, Dj3D, Dj_h3D,...
    alpha_tilde_sjk3D, betajs3D, consjs3D, epsilon_s3D, theta_s3D, eta_s3D, delta_s3D, sigma_s3D,...
    tijs3D, tijs_p3D, phiijs_h3D, Lijs3D, LABOR)
% this function generates new data-set for the case of zero trade deficit
% summer vectors
ln=ones(N,1);
%X0=abs(X0); % to avoid complex numbers

% construct 3D cubes from 1D vector X0
cis_h=x_fsolve(1:N*S,1);
cis_h2D=reshape(cis_h,S,N);
cis_h3D=reshape(kron(cis_h2D',ln'),N,N,S);
%cjs_h3D=permute(cis_h3D,[2 1 3]);
yis_h=x_fsolve((N*S+1):(2*N*S),1);
yis_h2D=reshape(yis_h,S,N);
yis_h3D=reshape(kron(yis_h2D',ln'),N,N,S);
yjs_h3D=permute(yis_h3D,[2 1 3]);
wi_h=x_fsolve((2*N*S+1):end,1);
wi_h3D=repmat(wi_h,[1 N S]);
wj_h3D=permute(wi_h3D,[2 1 3]);
ysjk_h3D=repmat(yis_h2D,[1 1 S]);	% y^_j,s in (s,j,k)
wsjk_h3D=repmat(wi_h',[S 1 S]);		% w^_j in (s,j,k)

betajk_sjk3D=repmat(consjs3D(1,:,:),[S 1 1]);  % beta_jk in (s,j,k)
epsilon_sjk3D=repmat(reshape(epsilon_s3D(1,1,:),S,1),[1 N S]);	% epsilon_s in (s,j,k)
%betajs_sjk3D=permute(repmat(betajs3D(1,:,:),[S,1,1]),[3 2 1]);
deltas_sjk3D=repmat(reshape(delta_s3D(1,1,:),S,1),[1 N S]);	% delta_s in (s,j,k)
etas_sjk3D=repmat(reshape(eta_s3D(1,1,:),S,1),[1 N S]);	% eta_s in (s,j,k)

if LABOR==1     % case when only labor enters fixed costs
    
%     mult_alpha=1-delta_s3D.*(1+eta_s3D)./(epsilon_s3D+1+eta_s3D);
%     alpha_sjk3D=alpha_tilde_sjk3D./repmat(reshape(mult_alpha(1,1,:),S,1),[1 N S]);  % alphas adjusted for fixed costs in labor
%     alpha_sj3D=repmat(sum(alpha_sjk3D,3),[1 1 S]);  % alpha_sj in (s,j,k)
%     alpha_si3D=permute(repmat(alpha_sj3D(:,:,1),[1 1 N]),[2 3 1]);
%     
%     PHIis3D=(sigma_s3D-delta_s3D)./((1-alpha_si3D).*(sigma_s3D-delta_s3D)+delta_s3D); % PHI_i,s in (i,j,s)
%     PHIiks3D=repmat(PHIis3D(:,1,:),[1 S 1]); % PHI_i,s in (i,k,s)
%     PHIsjk3D=permute(PHIiks3D,[3 1 2]);	% PHI_j,s in (s,j,k)
% 
%     Yi=Yi3D(:,1,1);
%     Ysjk3D=repmat(Yi',[S 1 S]);	% Y_j, (s,j,k)
%     kj3D=1./(1-repmat(sum(sum(tijs3D.*Lijs3D.*betajs3D./(1+tijs3D),3),1),[N 1 S])); % kappa_j in (i,j,s)
% 
%     AUX5_LABsjk=alpha_sjk3D.*PHIsjk3D.*ysjk3D.*Ysjk3D;
%     AUX5_LAB=repmat(sum(AUX5_LABsjk,1),[N 1 1]);   %(i,j,s)
%     AUX6_LAB=repmat(sum(sum(tijs3D.*Lijs3D.*AUX5_LAB./(1+tijs3D),3),1),[N 1 S]);
%     Ejs3D=betajs3D.*kj3D.*(Yj3D+Dj3D+AUX6_LAB)+AUX5_LAB;  % Ejs for labor in fixed costs
%     %CHECK: ERR00=Xijs3D-Lijs3D.*Ejs3D;
%         
%     AUX0=Lijs3D.* (yis_h3D.^delta_s3D).* ((cis_h3D.*phiijs_h3D).^(-theta_s3D)).*(wi_h3D.^(-eta_s3D.*delta_s3D));
%     AUX1=repmat(sum(AUX0,1),[N 1 1]);   % NxNxS (i,j,s)
%     
%     % 1. Compute lambda_hat_ijs
%     AUX2=AUX0./AUX1;    % lambda^ * lambda
%     Lijs_new3D=AUX2;    % lambda_prime
%     Lijs_h3D=Lijs_new3D./Lijs3D;    % lambda_hat
%     idx=find(eye(N));
%     Lijs_h2D=reshape(Lijs_h3D,N*N,S);	% i,s
%     Liis_h2D=Lijs_h2D(idx,:);	% Xii,s in (i,s)
%     Ljjs_h3D=permute(repmat(Liis_h2D,[1 1 N]),[3 1 2]);	% Ljj,s_hat in (i,j,s)
% 
%     AUX3sjk=alpha_sjk3D.*PHIsjk3D.*ysjk_h3D.*ysjk3D.*Ysjk3D.*wsjk_h3D;    % (s,j,k)
%     AUX3=repmat(sum(AUX3sjk,1),[N 1 1]);   %(i,j,s)
%     AUX3_5=repmat(sum(sum(tijs_p3D.*AUX2.*AUX3./(1+tijs_p3D),3),1),[N 1 S]);
%     kj_p3D=1./(1-repmat(sum(sum(tijs_p3D.*AUX2.*betajs3D./(1+tijs_p3D),3),1),[N 1 S])); % kappa'_j in (i,j,s)
%     AUX4=betajs3D.*kj_p3D.*(wj_h3D.*Yj3D+Dj3D.*Dj_h3D.*(wj_h3D.^mu)+AUX3_5)+AUX3;   % Ejs^ * Ejs
%     Ejs_h3D=AUX4./Ejs3D;    % E^js
%     
%     % compute a's
%     a_ksj3D=zeros(S,S,N);
%     for j=1:N
%        Aj=reshape(alpha_sjk3D(:,j,:),S,S); 
%        a_ksj3D(:,:,j)=(eye(S)-Aj)^(-1);
%     end
%     a_sjk3D=permute(a_ksj3D,[2 3 1]);
%     
%     % compute Cj^
%     AUX9=(yjs_h3D.^delta_s3D) .* (Ejs_h3D./wj_h3D).^(eta_s3D.*delta_s3D) ./ (Ljjs_h3D); % in (i,j,s)
%     AUX9sjk=permute(repmat(AUX9(1,:,:),[S,1,1]),[3 2 1]); 
%     AUX10sjk=(AUX9sjk).^(betajk_sjk3D.*a_sjk3D./epsilon_sjk3D);
%     AUX11=repmat(prod(prod(AUX10sjk,3),1),[N 1 S]);
%     Cj3D=kj_p3D.*(wj_h3D.*Yj3D+Dj_h3D.*Dj3D.*wj_h3D.^mu).*AUX11./(kj3D.*(Yj3D+Dj3D).*wj_h3D);
%     Cj=reshape(Cj3D(1,:,1),N,1);
else            % case when both labor and intermediate goods enter fixed costs
    
    alpha_sjk3D=alpha_tilde_sjk3D;  % alphas should not be adjusted if fixed costs include bundle of intermediate goods
    alpha_sj3D=repmat(sum(alpha_sjk3D,3),[1 1 S]);
    alpha_si3D=permute(repmat(alpha_sj3D(:,:,1),[1 1 N]),[2 3 1]);  % alpha_is in (i,j,s)
    
    Yi=Yi3D(:,1,1);
    Ysjk3D=repmat(Yi',[S 1 S]);	% Y_j, (s,j,k)
    kj3D=1./(1-repmat(sum(sum(tijs3D.*Lijs3D.*betajs3D./(1+tijs3D),3),1),[N 1 S])); % kappa_j in (i,j,s)
    
    AUX5_INTsjk=alpha_sjk3D.*ysjk3D.*Ysjk3D./(1-alpha_sj3D);
    AUX5_INT=repmat(sum(AUX5_INTsjk,1),[N 1 1]);   %(i,j,s)
    AUX6_INT=repmat(sum(sum(tijs3D.*Lijs3D.*AUX5_INT./(1+tijs3D),3),1),[N 1 S]);
    Ejs3D=betajs3D.*kj3D.*(Yj3D+Dj3D+AUX6_INT)+AUX5_INT;  % Ejs for intermed. goods in fixed costs

    AUX0=Lijs3D.* (yis_h3D.*wi_h3D./cis_h3D).^delta_s3D .* (cis_h3D.*phiijs_h3D).^(-theta_s3D).*(cis_h3D.^(-eta_s3D.*delta_s3D));
    AUX1=repmat(sum(AUX0,1),[N 1 1]);   % NxNxS (i,j,s)
    
    % 1. Compute lambda_hat_ijs
    AUX2=AUX0./AUX1;    % lambda^ * lambda
    Lijs_new3D=AUX2;    % lambda_prime
    Lijs_h3D=Lijs_new3D./Lijs3D;    % lambda_hat
    idx=find(eye(N));
    Lijs_h2D=reshape(Lijs_h3D,N*N,S);	% i,s
    Lijs_p3D=Lijs_new3D;
    Liis_h2D=Lijs_h2D(idx,:);	% Xii,s in (i,s)
    Ljjs_h3D=permute(repmat(Liis_h2D,[1 1 N]),[3 1 2]);	% Xjj,s in (i,j,s)   
    
    pij_p3D=repmat(sum(sum(tijs_p3D.*Lijs_p3D.*betajs3D./(1+tijs_p3D),3),1),[N 1 S]);
    Ri_p3D=repmat(sum(Ris3D.*yis_h3D.*wi_h3D,3),[1 1 S]);
    Rj_p3D=permute(Ri_p3D,[2 1 3]);
    
    AUX3sjk=alpha_sjk3D.*ysjk_h3D.*ysjk3D.*Ysjk3D.*wsjk_h3D./(1-alpha_sj3D);    % (s,j,k)
    AUX3=repmat(sum(AUX3sjk,1),[N 1 1]);   %(i,j,s)
    AUX3_5=repmat(sum(sum(tijs_p3D.*AUX2.*AUX3./(1+tijs_p3D),3),1),[N 1 S]);
    kj_p3D=1./(1-repmat(sum(sum(tijs_p3D.*AUX2.*betajs3D./(1+tijs_p3D),3),1),[N 1 S])); % kappa'_j in (i,j,s)
    AUX4=betajs3D.*kj_p3D.*(wj_h3D.*Yj3D+Dj3D.*Dj_h3D.*(wj_h3D.^mu)+AUX3_5)+AUX3;   % Ejs^ * Ejs
    Ejs_h3D=AUX4./Ejs3D;    % E^js

    % compute a's
    alpha_p_sjk3D=alpha_sjk3D.*(1+deltas_sjk3D.*(1+etas_sjk3D)./epsilon_sjk3D);
    a_ksj3D=zeros(S,S,N);
    for j=1:N
       Aj=reshape(alpha_p_sjk3D(:,j,:),S,S); 
       a_ksj3D(:,:,j)=(eye(S)-Aj)^(-1);
    end
    a_sjk3D=permute(a_ksj3D,[2 3 1]);
    
    % compute Cj^
    AUX9=(yjs_h3D.^delta_s3D) .* (Ejs_h3D./wj_h3D).^(eta_s3D.*delta_s3D) ./ (Ljjs_h3D); % in (i,j,s)
    AUX9sjk=permute(repmat(AUX9(1,:,:),[S,1,1]),[3 2 1]); 
    AUX10sjk=(AUX9sjk).^(betajk_sjk3D.*a_sjk3D./epsilon_sjk3D);
    AUX11=repmat(prod(prod(AUX10sjk,3),1),[N 1 S]);
    Cj3D=(wj_h3D+Rj_p3D.*pij_p3D./(Yj3D.*(1-pij_p3D))).*AUX11./wj_h3D;
    Cj=reshape(Cj3D(1,:,1),N,1);
end

end
