%==========================================================================
% Step 04: this file generates the "new" data which comes from the solution
% of the system for zero trade deficits, D=0
%==========================================================================
clear all;

% Load data from Step_01 and Step_03 -- all variables in the loaded data are "cubes" NxNxS: (i,j,s);
load Step_01_WIOD_AGG_no_INT.mat;
load Step_03_DATA_D0.mat

wj_h3D=permute(wi_h3D,[2 1 3]);
tauijs_h3D=ones(N,N,S);   % "cube" of tau_ijs_hat's
tijs_p3D=zeros(N,N,S);
tijs3D=zeros(N,N,S);
Dj_h3D=zeros(N,N,S);
phiijs3D=tauijs_h3D.*(1+tijs_p3D)./(1+tijs3D);  % ratio of shipping costs (trans+tariffs): t'/t

% 1. Compute lambda_hat_ijs
AUX0=((phiijs3D.*wi_h3D).^(1-sigma_s3D));
AUX1=repmat(sum(Lijs3D.*AUX0,1),[N 1 1]);
Lijs_h3D=AUX0./AUX1;

% 2. Compute "new" lambda_hat_ijs (for D=0)
Lijs_new3D=Lijs3D.*Lijs_h3D;

% 3. Compute "new" Y_i (for D=0)
Yi_new3D=Yi3D.*wi_h3D;  % making use of Y^i=w^i

% 4. Compute "new" y_is, Yis
yis3D=Yis3D./Yi3D;
yis_new3D=yis3D.*yis_h3D;
Yis_new3D=yis_new3D.*Yi_new3D;

% 5. Compute kappa and kappa'
AUX_k=tijs3D.*Lijs3D.*betajs3D./(1+tijs3D);
AUX_k_p=tijs_p3D.*Lijs3D.*Lijs_new3D.*betajs3D./(1+tijs_p3D);
kappaj3D=1./(1-repmat(sum(sum(AUX_k,3),1),[N 1 S]));
kappaj_p3D=1./(1-repmat(sum(sum(AUX_k_p,3),1),[N 1 S]));

% 6. Compute Ejs, Ejs*E^js, and E^js
Ejs3D=betajs3D.*kappaj3D.*(Yj3D+Dj3D);  % Ejs
EjsEjs_h3D=betajs3D.*kappaj_p3D.*(wj_h3D.*Yj3D+Dj_h3D.*Dj3D.*(wj_h3D.^mu)); % Ejs*E^js
Ejs_h3D=EjsEjs_h3D./Ejs3D;  % E^js

% 7. Compute Xijs_h3D and Xijs_new3D
Xijs_h3D=Lijs_h3D.*Ejs_h3D;
Xijs_new3D=Xijs_h3D.*Xijs3D;
% % CHECK that lambda_new and Xijs_new are consistent
% Xjs_new3D=repmat(sum(Xijs_new3D,1),[N 1 1]);
% Lijs_new_alt3D=Xijs_new3D./Xjs_new3D; ANS=Lijs_new_alt3D-Lijs_new3D;

Dj_new3D=zeros(N,N,S);

save Step_04_DATA_D0_PC.mat N S mu yis_new3D Yi_new3D Lijs_new3D Dj_new3D epsilon_s3D sigma_s3D betajs3D consjs3D

% save the new data in an extended version (with Xijs)
save Step_04_DATA_D0_PC_extd.mat N S mu yis_new3D Yi_new3D Yis_new3D Xijs_new3D Lijs_new3D Dj_new3D epsilon_s3D sigma_s3D betajs3D consjs3D
