%==========================================================================
% Step 11: task 8), "Yury final tasks for paper Jan 29"
%==========================================================================
clear all;

% ------------- Load the non-zero-deficit data (see Step_01 for details)
load Step_01_WIOD_AGG_with_INT.mat;

% ------------- Aggregate all sectors into: S=35 --> S=1
S=1;
Yi3D=Yi3D(:,:,1);       Dj3D=Dj3D(:,:,1);
Xij2D=sum(Xijs3D,3);    Xj2D=repmat(sum(Xij2D,1),[N 1]);    Lijs3D=Xij2D./Xj2D;
betajs3D=ones(N,N,S);   epsilon_s3D=5*ones(N,N,S);          sigma_s3D=epsilon_s3D+1;
consjs3D=ones(N,N,S);

% ------------- Set other parameters
% Initial and new tariffs (0% and 40% for all countries)
tijs3D=zeros(N,N,S);
t_p=0.4; tij_p2D=t_p*(ones(N)-eye(N)); tijs_p3D=repmat(tij_p2D,[1 1 S]);

% Changes in transportation costs
tau_h=1;    tauij_h2D=tau_h*ones(N)+(1-tau_h)*eye(N);   tauijs_h3D=repmat(tauij_h2D,[1 1 S]);

% Other parameters
Dj_h3D=ones(N,N,S);	% keep all trade deficits as they are in the data
X0=ones(N,1);

% ------------- Compute a new equilibrium for the system
mu=1;
syst=@(X) DEK_TRF_SYSTEM_N1(X, N ,S, mu, Yi3D, Dj3D, Dj_h3D, betajs3D, sigma_s3D, tijs3D, tijs_p3D, tauijs_h3D, Lijs3D);
options=optimset('MaxFunEvals',50000000,'MaxIter',5000,'TolFun',1e-20,'TolX',1e-20); 
[x_fsolve,fval_fsolve]=fsolve(syst, X0, options);
max(abs(fval_fsolve))  % check the accuracy of solution
wi_h=abs(x_fsolve((end-N+1):end,1));
wi_h3D=repmat(wi_h,[1 N S]);
[wj_h, Pj_h, Ej_h, Cj_h]=DEK_WELFARE2_N1(wi_h3D, N , S, mu, Yi3D, Dj3D, Dj_h3D, betajs3D, consjs3D, sigma_s3D, tijs3D, tijs_p3D, tauijs_h3D, Lijs3D);
kj_h=Ej_h./wj_h;
Pj_h=1./Pj_h;
RESULT_mu_1=[wj_h, kj_h, Pj_h, Cj_h];

mu=0;
syst=@(X) DEK_TRF_SYSTEM_N1(X, N ,S, mu, Yi3D, Dj3D, Dj_h3D, betajs3D, sigma_s3D, tijs3D, tijs_p3D, tauijs_h3D, Lijs3D);
options=optimset('MaxFunEvals',50000000,'MaxIter',5000,'TolFun',1e-20,'TolX',1e-20); 
[x_fsolve,fval_fsolve]=fsolve(syst, X0, options);
max(abs(fval_fsolve))  % check the accuracy of solution
wi_h=abs(x_fsolve((end-N+1):end,1));
wi_h3D=repmat(wi_h,[1 N S]);
[wj_h, Pj_h, Ej_h, Cj_h]=DEK_WELFARE2_N1(wi_h3D, N , S, mu, Yi3D, Dj3D, Dj_h3D, betajs3D, consjs3D, sigma_s3D, tijs3D, tijs_p3D, tauijs_h3D, Lijs3D);
kj_h=Ej_h./wj_h;
Pj_h=1./Pj_h;
RESULT_mu_0=[wj_h, kj_h, Pj_h, Cj_h];

% ------------- Save the result as a table
save Figure_3.mat RESULT_mu_0 RESULT_mu_1
ANS=Dj3D./Yj3D(:,:,1);
D_GDP=reshape(ANS(1,:,1),N,1);
RESULT=[RESULT_mu_0,RESULT_mu_1,D_GDP];
dlmwrite('Figure_3.csv',RESULT);

% scatter plot
S={'AUS' 'AUT' 'BEL' 'BRA' 'CAN' 'CHN' 'CZE' 'DEU' 'DNK' 'ESP' 'FIN' 'FRA' 'GBR' 'GRC' 'HUN' 'IDN' 'IND' 'IRL' 'ITA' 'JPN' 'KOR' 'MEX' 'NLD' 'POL' 'PRT' 'ROM' 'RUS' 'SVK' 'SVN' 'SWE' 'TUR' 'TWN' 'USA' 'ROW'};
c_l=cellstr(S);
x=RESULT_mu_0(:,end);
y=RESULT_mu_1(:,end);
dx=0.0007; dy=0.0005;
f=figure;
scatter(x,y,30,'o','filled');
grid('on');
text(x+dx,y,c_l);
xlabel('Welfare Changes with Deficits Proportional to World GDP'); 
ylabel('Welfare Changes with Deficits Proportional to Domestic GDP');
mmin=min(min(x),min(y))-0.005;
mmax=max(max(x),max(y))+0.005;
axis([mmin mmax mmin mmax]);
line([mmin, mmax],[mmin, mmax],'linewidth',1,'linestyle','--');
saveas(f,'Figure_3.eps','eps2c');

